package com.liang.dao;

import com.liang.entity.BaseCompany;
import com.liang.entity.BaseDegree;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;
import java.util.Map;

/**
 * (BaseDegree)表数据库访问层
 *
 * @author makejava
 * @since 2023-02-15 23:13:16
 */
public interface BaseDegreeDao {

    /**
     * 通过ID查询单条数据
     *
     * @param Genid 主键
     * @return 实例对象
     */
    BaseDegree queryById(Integer Genid);

    /**
     * 查询指定行数据
     *
     * @param baseDegree 查询条件
     * @param pageable   分页对象
     * @return 对象列表
     */
    List<BaseDegree> queryAllByLimit(BaseDegree baseDegree, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param baseDegree 查询条件
     * @return 总行数
     */
    long count(BaseDegree baseDegree);

    /**
     * 新增数据
     *
     * @param baseDegree 实例对象
     * @return 影响行数
     */
    int insert(BaseDegree baseDegree);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<BaseDegree> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<BaseDegree> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<BaseDegree> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<BaseDegree> entities);

    /**
     * 修改数据
     *
     * @param baseDegree 实例对象
     * @return 影响行数
     */
    int update(BaseDegree baseDegree);

    /**
     * 通过主键删除数据
     *
     * @param Genid 主键
     * @return 影响行数
     */
    int deleteById(Integer Genid);

    /**
     * 获取学位列表
     *
     * @return
     */
    List<Map<String, String>> getDegreeList();
}

